"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.until = void 0;
const runtime_dom_1 = require("@vue/runtime-dom");
async function until(source, options = {}) {
    let stop = null;
    const { timeout, ...watchOptions } = options;
    const match = options.match === undefined
        ? matchTruthy : options.match instanceof Function
        ? options.match : matcher(options.match);
    const promises = [new Promise(function setup(resolve) {
            stop = (0, runtime_dom_1.watch)(source, function onChange(next) {
                if (match(next)) {
                    stop?.();
                    resolve();
                }
            }, watchOptions);
        }),];
    if (timeout) {
        promises.push(new Promise(function setup(_, reject) {
            setTimeout(reject, timeout);
        }).finally(function onFinally() {
            stop?.();
        }));
    }
    return 1 < promises.length ? Promise.race(promises) : promises[0];
}
exports.until = until;
function matcher(value) {
    return function matches(next) {
        return value === next;
    };
}
function matchTruthy(value) {
    return !!value;
}
