"use strict";
/* eslint-disable @typescript-eslint/no-shadow */
Object.defineProperty(exports, "__esModule", { value: true });
exports.extend = void 0;
const runtime_dom_1 = require("@vue/runtime-dom");
function extend(ref, extend, { enumerable = true, unwrap = true, } = {}) {
    function define(key, value) {
        Object.defineProperty(ref, key, {
            get() { return value.value; },
            set(v) { value.value = v; },
            enumerable,
        });
    }
    for (const [key, value,] of Object.entries(extend)) {
        if ("value" === key) {
            continue;
        }
        if (unwrap && (0, runtime_dom_1.isRef)(value)) {
            define(key, value);
        }
        else {
            Object.defineProperty(ref, key, { value, enumerable, });
        }
    }
}
exports.extend = extend;
