/* eslint-disable @typescript-eslint/no-shadow */
import { readonly, shallowRef, watchEffect } from "@vue/runtime-dom";
/*
https://dev.to/linusborg/vue-when-a-computed-property-can-be-the-wrong-tool-195j

Use computed() when you have a complex
calculation going on, which can actually profit
from caching and lazy evaluation and should only
be (re-)calculated if really necessary.

Use eagerComputed() when you have a simple
operation, with a rarely changing return value –
often a boolean.
*/
export function eager(factory) {
    const result = shallowRef();
    watchEffect(function onEffect() {
        result.value = factory();
    }, { flush: "sync", });
    return readonly(result);
}
